.386
.model flat,stdcall
option casemap:none


Viewer 			proto :DWORD,:DWORD,:DWORD,:DWORD
LoadBmp 		proto 
SaveBmp 		proto
CenterWnd 		proto :DWORD,:DWORD
GrayScale 		proto
PrepareParse 		proto :DWORD

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\gdi32.lib

.const


.data
ClassName		 db "BmpView",0
AppName 		 db "Viewer",0

ofn  			 OPENFILENAME <>
strFilter 		 db "bmp files",0,"*.bmp",0,0
buffer 			 db 260 dup(0)
OpenTitle 		 db "Open BMP file",0
SaveTitle		 db "Save BMP file",0


bMask			 dd 0



strtitle		 db 256 dup(0)	
strMask			 db 'Mask:',0
strMaskValue		 db 10 dup (0) 
strStatus		 db 'Invert&Bright:',0
strfmt			 db '%X',0
strTrue			 db 'TRUE',0
strFalse		 db 'FALSE',0
strdump			 db '  ',0
strTemFile		 db 'c:\1.bmp',0
strSave			 db 'Wanna save the bmp?',0



rBalance		 dw 299
gBalance		 dw 587
bBalance		 dw 114
wDivisor		 dw 1000		 

.data?
hInstance 		       dd ?
CommandLine 		       dd ?

bf		       	       BITMAPFILEHEADER <>
bi			       BITMAPINFOHEADER <>
rect 			       RECT <> 

hwnd			       dd ?
hHeap			       dd ?
rdbytes			       dd ?
bmpsize			       dd ?
bmpsize2		       dd ?
hbmp			       dd ?
fGray			       dd ?
hFiles			       dd ?
hFiled			       dd ?
pHeap			       dd ?
pHeap2			       dd ?
bmpWidth		       dd ?
spw			       dd ?	
nY			       dd ?


.code
start:
	invoke GetProcessHeap
	mov hHeap,eax
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke Viewer, hInstance,NULL,CommandLine, SW_SHOWDEFAULT	
	invoke ExitProcess,eax


Viewer proc hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov   wc.cbSize,sizeof WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, offset WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BACKGROUND + 1
	mov   wc.lpszMenuName,1
	mov   wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,0,addr ClassName,addr AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,479,359,NULL,NULL,hInst,NULL
    
	mov   hwnd,eax
	invoke ShowWindow,eax,SW_SHOWNORMAL
	invoke UpdateWindow,hwnd
	.while TRUE
		invoke GetMessage, addr msg,NULL,0,0
                .break .IF (!eax)
                invoke TranslateMessage, addr msg
                invoke DispatchMessage, addr msg
	.endw
	mov     eax,msg.wParam
	ret
Viewer endp

LoadBmp proc 
	

	
	mov esi,pHeap
	mov edi,pHeap2
	mov ecx,bmpsize
	.while ecx > 0
		mov eax,[esi]
		mov [edi],eax
		add esi,4
		add edi,4
		sub ecx,4
	.endw
	
	.if fGray
		invoke GrayScale
	.endif
	
	mov ecx,bi.biHeight
	
	mov edi,pHeap2
	.while ecx > 0
		push ecx
		
		mov ecx,bmpWidth

		bt bMask,25
		.if CARRY?
			.while ecx > 0
				mov al,[edi]
				mov bl,0ffh
				sub bl,al
				mov [edi],bl
				
				inc edi
				dec ecx
			.endw
		
			mov ecx,bmpWidth
			
			sub edi,ecx
		
		.endif
		bt bMask,26
		jnc @f
			.while ecx > 0
				mov al,[edi]
				sub al,18
				mov [edi],al
				
				inc edi
				dec ecx
			.endw
			
			mov ecx,bmpWidth
			
			sub edi,ecx
		@@:
       
		
		
		add edi,spw
		pop ecx
		dec ecx

	.endw
	mov fGray,0
	invoke CreateFile,addr strTemFile,GENERIC_WRITE,FILE_SHARE_WRITE or FILE_SHARE_DELETE or FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hFiled,eax
	invoke WriteFile,hFiled,addr bf,sizeof bf,addr rdbytes,0
	invoke WriteFile,hFiled,addr bi,sizeof bi,addr rdbytes,0
	invoke WriteFile,hFiled,pHeap2,bmpsize,addr rdbytes,0
	invoke CloseHandle,hFiled

	invoke LoadImage,0,addr strTemFile,IMAGE_BITMAP,0,0,LR_LOADFROMFILE	
	mov hbmp,eax
	invoke  InvalidateRect,hwnd,NULL,NULL
        invoke  UpdateWindow,hwnd

	ret
LoadBmp endp


WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	Local ps :PAINTSTRUCT
	Local hmemdc :DWORD	
	Local hbmpPrev:DWORD

	
	.if uMsg==WM_DESTROY
		
		invoke KillTimer,hWnd,100
		invoke PostQuitMessage,NULL
	
	.elseif uMsg == WM_CREATE

		invoke SetTimer,hWnd,100,100,0
		mov ofn.lStructSize,SIZEOF ofn
		push hWnd
		pop  ofn.hWndOwner
		push hInstance
		pop  ofn.hInstance
		mov  ofn.lpstrFilter, offset strFilter
		mov  ofn.lpstrFile, offset buffer
		mov  ofn.nMaxFile,260
		mov  ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
                mov  ofn.lpstrTitle, offset OpenTitle
	
	.elseif uMsg==WM_TIMER
		invoke lstrcpy,addr strtitle,addr strMask
		invoke lstrcat,addr strtitle,addr strdump
		invoke wsprintf,addr strMaskValue,addr strfmt,bMask 
		invoke lstrcat,addr strtitle,addr strMaskValue
		invoke lstrcat,addr strtitle,addr strdump
		invoke lstrcat,addr strtitle,addr strStatus
		invoke lstrcat,addr strtitle,addr strdump
		.if bMask & 2000000h
			invoke lstrcat,addr strtitle,addr strTrue
		.else
			invoke lstrcat,addr strtitle,addr strFalse
		.endif
		invoke lstrcat,addr strtitle,addr strdump
		.if bMask & 4000000h
			invoke lstrcat,addr strtitle,addr strTrue
		.else
			invoke lstrcat,addr strtitle,addr strFalse
		.endif
		invoke SetWindowText,hWnd,addr strtitle
		
	.elseif uMsg==WM_PAINT
		
		 invoke  BeginPaint,hWnd,addr ps
       		 .if hbmp
            		invoke  CreateCompatibleDC,eax
           		mov     hmemdc,eax
           		invoke  SelectObject,eax,hbmp
            		mov     hbmpPrev,eax
           		mov     ecx,ps.rcPaint.right
           		mov     edx,ps.rcPaint.bottom
            		mov     eax,bi.biWidth
            		.if eax<ecx
                		xchg    eax,ecx
            		.endif
           		 mov     eax,bi.biHeight
            		.if eax<edx
               			 xchg    eax,edx
            		.endif
           		 sub     ecx,ps.rcPaint.left
            		 sub     edx,ps.rcPaint.top
            		invoke  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ecx,edx,hmemdc,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
                   	
            		invoke  SelectObject,hmemdc,hbmpPrev
           	 	invoke  DeleteDC,hmemdc

        	;.else
           	;	mov     ecx,ps.rcPaint.right
            	;	mov     edx,ps.rcPaint.bottom
           	;	sub     ecx,ps.rcPaint.left
            	;	sub     edx,ps.rcPaint.top
            	;	invoke  PatBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ecx,edx,WHITENESS

        	.endif

        	invoke  EndPaint,hWnd,addr ps

	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		.if ax == 1

			invoke GetOpenFileName,addr ofn
			.if eax==TRUE
				invoke PrepareParse,ofn.lpstrFile
				invoke LoadBmp
			.endif

		
		.elseif ax == 8
			or bMask,2000000h
		.elseif ax == 9
			and bMask,5ffffffh
		.elseif ax == 10
			or bMask,4000000h
		.elseif ax == 11
			and bMask,3ffffffh
		.elseif ax == 12
			invoke LoadBmp
		.elseif ax == 13
			mov fGray,1
		.endif

	.elseif uMsg == WM_CLOSE
		.if hbmp
			invoke SaveBmp
		.endif
		invoke HeapFree,hHeap,0,pHeap
		invoke DeleteFile,addr strTemFile
		invoke DestroyWindow,hWnd
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret
WndProc endp






CenterWnd proc wDim,sDim
	shr sDim,1
	shr wDim,1
	mov eax,wDim
	sub sDim,eax
	mov eax,sDim
	ret
CenterWnd endp



PrepareParse proc pszfile

	invoke CreateFile,pszfile,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	mov hFiles,eax
	invoke ReadFile,hFiles,addr bf,sizeof bf,addr rdbytes,0
	invoke ReadFile,hFiles,addr bi,sizeof bi,addr rdbytes,0
	
	push bi.biWidth
	push bi.biHeight
	add bi.biWidth,8				;borderwidth == 4 & 4
	add bi.biHeight,44				;borderwidth == 4(bottom) & 40(top)
	invoke GetSystemMetrics,SM_CXSCREEN
	invoke CenterWnd,bi.biWidth,eax
	mov ebx,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	invoke CenterWnd,bi.biHeight,eax	
	invoke SetWindowPos,hwnd,HWND_TOP,ebx,eax,bi.biWidth,bi.biHeight,SWP_SHOWWINDOW 
	pop bi.biHeight
	pop bi.biWidth

;--------calculate the bmpWidth&spw-----------
	
	mov eax,bi.biWidth
	mov ecx,3
	mul ecx
	xchg ebx,eax    
	mov bmpWidth,ebx	

	mov eax,bf.bfSize
	sub eax,54
	mov bmpsize,eax
	
	mov ecx,bi.biHeight
	div ecx
	mov spw,eax
;---------------------------------------------

	mov eax,bmpsize
	sub eax,bmpsize2
	jna  @f
	.if !pHeap
		invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,bmpsize
		mov pHeap,eax
		
	.else
		invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,pHeap,bmpsize
		mov pHeap,eax 
	.endif
	
	push bmpsize
	pop bmpsize2
	@@:
	invoke ReadFile,hFiles,pHeap,bmpsize,addr rdbytes,0
	invoke CloseHandle,hFiles
	invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,bmpsize

	mov pHeap2,eax

;------------------------------------
	

	ret
PrepareParse endp

GrayScale proc
	mov esi,pHeap2
	mov ecx,bi.biHeight
	.while ecx > 0
		push ecx
		
		mov ecx,bmpWidth
		push esi
		.while ecx > 0
			
			movzx ax, BYTE PTR [esi]
			mul bBalance
			div wDivisor
			xchg bl,al
			
			movzx ax, BYTE PTR [esi+1]
			mul gBalance
			div wDivisor
			add bl,al
			
			movzx ax, BYTE PTR [esi+2]
			mul rBalance
			div wDivisor
			add bl,al
			
			mov [esi],bl
			mov [esi+1],bl
			mov [esi+2],bl
				
			add esi,3
			sub ecx,3
		.endw
		pop esi
		add esi,spw
		pop ecx
		dec ecx
	.endw
	ret
GrayScale endp

SaveBmp proc
	invoke MessageBox,hwnd,addr strSave,addr AppName,MB_YESNO
	.if eax == IDYES
		mov  ofn.lpstrTitle,offset SaveTitle
		mov  ofn.lpstrDefExt,offset strFilter
		invoke GetSaveFileName,addr ofn
		invoke CreateFile,ofn.lpstrFile,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_WRITE or FILE_SHARE_DELETE or FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
		mov hFiled,eax
		invoke WriteFile,hFiled,addr bf,sizeof bf,addr rdbytes,0
		invoke WriteFile,hFiled,addr bi,sizeof bi,addr rdbytes,0
		invoke WriteFile,hFiled,pHeap2,bmpsize,addr rdbytes,0
		invoke CloseHandle,hFiled
		
	.endif

	ret
SaveBmp endp

end start
